{
    "$graph": [
        {
            "class": "Workflow",
            "inputs": [
                {
                    "type": "string",
                    "id": "#1st-workflow.cwl/name_of_file_to_extract"
                },
                {
                    "type": "File",
                    "id": "#1st-workflow.cwl/tarball"
                }
            ],
            "steps": [
                {
                    "run": "#arguments.cwl",
                    "in": [
                        {
                            "source": "#1st-workflow.cwl/untar/extracted_file",
                            "id": "#1st-workflow.cwl/compile/src"
                        }
                    ],
                    "out": [
                        "#1st-workflow.cwl/compile/classfile"
                    ],
                    "id": "#1st-workflow.cwl/compile"
                },
                {
                    "run": "#tar-param.cwl",
                    "in": [
                        {
                            "source": "#1st-workflow.cwl/name_of_file_to_extract",
                            "id": "#1st-workflow.cwl/untar/extractfile"
                        },
                        {
                            "source": "#1st-workflow.cwl/tarball",
                            "id": "#1st-workflow.cwl/untar/tarfile"
                        }
                    ],
                    "out": [
                        "#1st-workflow.cwl/untar/extracted_file"
                    ],
                    "id": "#1st-workflow.cwl/untar"
                }
            ],
            "id": "#1st-workflow.cwl",
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#1st-workflow.cwl/compile/classfile",
                    "id": "#1st-workflow.cwl/compiled_class"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "Example trivial wrapper for Java 9 compiler",
            "hints": [
                {
                    "dockerPull": "openjdk:9.0.1-11-slim",
                    "class": "DockerRequirement"
                }
            ],
            "baseCommand": "javac",
            "arguments": [
                "-d",
                "$(runtime.outdir)"
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#arguments.cwl/src"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.class"
                    },
                    "id": "#arguments.cwl/classfile"
                }
            ],
            "id": "#arguments.cwl"
        },
        {
            "class": "Workflow",
            "inputs": [],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/compile/compiled_class",
                    "id": "#main/classout"
                }
            ],
            "requirements": [
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "steps": [
                {
                    "run": "#1st-workflow.cwl",
                    "in": [
                        {
                            "default": "Hello.java",
                            "id": "#main/compile/name_of_file_to_extract"
                        },
                        {
                            "source": "#main/create-tar/tar_compressed_java_file",
                            "id": "#main/compile/tarball"
                        }
                    ],
                    "out": [
                        "#main/compile/compiled_class"
                    ],
                    "id": "#main/compile"
                },
                {
                    "in": [],
                    "out": [
                        "#main/create-tar/tar_compressed_java_file"
                    ],
                    "run": {
                        "class": "CommandLineTool",
                        "requirements": [
                            {
                                "listing": [
                                    {
                                        "entryname": "Hello.java",
                                        "entry": "public class Hello {\n  public static void main(String[] argv) {\n      System.out.println(\"Hello from Java\");\n  }\n}\n"
                                    }
                                ],
                                "class": "InitialWorkDirRequirement"
                            }
                        ],
                        "inputs": [],
                        "baseCommand": [
                            "tar",
                            "--create",
                            "--file=hello.tar",
                            "Hello.java"
                        ],
                        "outputs": [
                            {
                                "type": "File",
                                "streamable": true,
                                "outputBinding": {
                                    "glob": "hello.tar"
                                },
                                "id": "#main/create-tar/4b8d7ac9-9e37-47f9-8dc8-e5da5904e6ef/tar_compressed_java_file"
                            }
                        ],
                        "id": "#main/create-tar/4b8d7ac9-9e37-47f9-8dc8-e5da5904e6ef"
                    },
                    "id": "#main/create-tar"
                }
            ],
            "id": "#main"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "tar",
                "--extract"
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#tar-param.cwl/extractfile"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--file"
                    },
                    "id": "#tar-param.cwl/tarfile"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.extractfile)"
                    },
                    "id": "#tar-param.cwl/extracted_file"
                }
            ],
            "id": "#tar-param.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
